hdu3709(求区间内平衡数的个数)数位dp

题意:题中平衡数的定义: 以一个位置作为平衡轴,然后左右其他数字本身大小作为重量,到平衡轴的距离作为全职,实现左右平衡(即杠杆原理平衡)。然后为区间[x,y]内平衡数的个数。 (0 ≤ x ≤ y ≤ 1018)

解法:数位dp。如果一个数的平衡数,那么它的平衡轴位置是确定的。原来一直尝试数位dp在dfs时候列举平衡轴的位置,后来才意识到可以提前枚举平衡轴位置,然后再dfs,这样比较好写。dp[mid][pre][wei];表示对称轴是mid,计算第pre个位置以后需要力矩大小wei的数的个数。

ps:这个题关键是跟着适牛学了点东西,首先原来自己写了一个now的无用的东西一维记录前一个数字是啥(受前边题目影响,习惯性思维),但是后来发现明显没用。虽然提交A掉了,但是我又尝试去掉那一维试了一下,发现wa了,半天也没发现错哪了,后来适牛提醒说有可能是数组越界了。最后才发现真相:由于原来多了一维,为数组越界提供了可靠的空间,这也是为什去掉之后才会wa的原因。开大了点wei的那一维就又AC了。还从适牛那里学到:由于mid确定后,dp是不变的,所以只需要memset一次就够了,加上wei>=(len*(len+1)/2*9)+2的剪枝后,做到了0ms。

代码:

/******************************************************
* author:xiefubao
*******************************************************/
#pragma comment(linker, "/STACK:102400000,102400000")
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <queue>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <stack>
#include <string.h>
//freopen ("in.txt" , "r" , stdin);
using namespace std;

#define eps 1e-8
const double pi=acos(-1.0);
typedef long long LL;
const int Max=10100;
const int INF=1000000007;
LL dp[20][20][410];
int num[20];
LL l,r;
int len=0;
LL dfs(int mid,int pre,int wei,bool limit)
{
    if(wei<0||wei>=(len*(len+1)/2*9)+2)
        return 0;
    if(pre==0)
        return wei==0;
    if(!limit&&dp[mid][pre][wei]!=-1)
        return dp[mid][pre][wei];
    int en=limit ? num[pre-1]:9;
    LL ans=0;
    for(int i=0; i<=en; i++)
    {
        if(pre-1==mid&&i==0&&wei==0) continue;
        ans+=dfs(mid,pre-1,wei+(pre-1-mid)*i,limit&&(i==en));
    }
    return (!limit) ? dp[mid][pre][wei]=ans : ans;
}
LL solve(LL n)
{
    if(n<0)
        return 0;
    int p=0;
    while(n)
    {
        num[p++]=n%10;
        n/=10;
    }
    len=p/2;
    LL ans=0;
    for(int mid=p-1; mid>=0; mid--)
    {
        for(int i=0; i<=num[p-1]; i++)
        {
          if(i==0&&mid==p-1) continue;
            ans+=dfs(mid,p-1,(p-1-mid)*i,i==num[p-1]);
        }
    }
    return ans+1;
}
int main()
{
    int t;
    cin>>t;
    memset(dp,-1,sizeof dp);
    while(t--)
    {
        scanf("%I64d%I64d",&l,&r);
        cout<<solve(r)-solve(l-1)<<‘\n‘;
    }
    return 0;
}

hdu3709(求区间内平衡数的个数)数位dp

时间: 2024-11-07 10:53:00

hdu3709(求区间内平衡数的个数)数位dp的相关文章

SPOJ 3267 D-query(离散化+主席树求区间内不同数的个数)

DQUERY - D-query #sorting #tree English Vietnamese Given a sequence of n numbers a1, a2, ..., an and a number of d-queries. A d-query is a pair (i, j) (1 ≤ i ≤ j ≤ n). For each d-query (i, j), you have to return the number of distinct elements in the

HDU4622:Reincarnation(后缀数组,求区间内不同子串的个数)

Problem Description Now you are back,and have a task to do: Given you a string s consist of lower-case English letters only,denote f(s) as the number of distinct sub-string of s. And you have some query,each time you should calculate f(s[l...r]), s[l

Codeforces Round #271 (Div. 2) F.Ant colony(线段树 + 统计区间内某数的个数)

F. Ant colony Mole is hungry again. He found one ant colony, consisting of n ants, ordered in a row. Each ant i (1 ≤ i ≤ n) has a strength si. In order to make his dinner more interesting, Mole organizes a version of «Hunger Games» for the ants. He c

SPOJ DQUERY 区间内不同数的个数 主席树

#include <iostream> #include <map> #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int MAXN = 30010,MAXLOG = 20; struct ChairTree { int l,r; int ans; }ct[MAXN*MAXLOG]; int ctRoot[MAXN]; in

POJ 2761-Feed the dogs(划分树)求区间内第k小的数

Feed the dogs Time Limit: 6000MS   Memory Limit: 65536K Total Submissions: 17679   Accepted: 5561 Description Wind loves pretty dogs very much, and she has n pet dogs. So Jiajia has to feed the dogs every day for Wind. Jiajia loves Wind, but not the

给出一个区间[a, b],计算区间内“神奇数”的个数。 神奇数的定义:存在不同位置的两个数位,组成一个两位数(且不含前导0),且这个两位数为质数。 比如:153,可以使用数字3和数字1组成13,13是质数,满足神奇数。同样153可以找到31和53也为质数,只要找到一个质数即满足神奇数。

给出一个区间[a, b],计算区间内"神奇数"的个数.神奇数的定义:存在不同位置的两个数位,组成一个两位数(且不含前导0),且这个两位数为质数.比如:153,可以使用数字3和数字1组成13,13是质数,满足神奇数.同样153可以找到31和53也为质数,只要找到一个质数即满足神奇数. 输入描述: 输入为两个整数a和b,代表[a, b]区间 (1 ≤ a ≤ b ≤ 10000). 输出描述: 输出为一个整数,表示区间内满足条件的整数个数 输入例子: 11 20 输出例子: 6 1 #in

HDU 4417 Super Mario(主席树求区间内的区间查询+离散化)

Super Mario Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 5101    Accepted Submission(s): 2339 Problem Description Mario is world-famous plumber. His “burly” figure and amazing jumping abilit

区间内x的出现个数(主席树)

题目大概:求区间内x出现的次数 出题人yjy Description ZJK 给你一个长度为 n 的数列和 m 次询问,每次询问从第 l 个到第 r 个数中,数 x 出现了多少次.Input第一行一个整数 n,第二行 n 个整数,表示这个数列.第三行一个整数 m,表示询问数.下面 m 行,每行三个整数 l, r, x,表示询问[l, r]之间数 x 出现的次数Output对于每个询问操作,输出该询问的答案.答案之间用换行隔开,一共 m 行.Example61 1 2 3 3 181 6 13 5

HDU5172GTY&#39;s gay friends——区间查询(区间内的数互不相同)

http://acm.split.hdu.edu.cn/showproblem.php?pid=5172 官方题解 一个区间是排列只需要区间和为len(len+1)2(len为区间长度),且互不相同,对于第一个问题我们用前缀和解决,对于第二个问题,预处理每个数的上次出现位置,记它为pre,互不相同即区间中pre的最大值小于左端点,使用线段树或Sparse Table即可在O(n)/O(nlogn)的预处理后 O(logn)/O(1)回答每个询问.不过我们还有更简单的hash做法,对于[1..n]